package original;

public class Tree {
	public long insert(LeafNode ln, byte[] key/* , ... */) {
		BottomNode bin = findBINForInsert(key/* , ... */);
		long position = ln.log(key/* , ... */);
		bin.updateEntry(ln, position, key);
		bin.clearKnownDeleted();
		trace(bin, ln, position);
		other();
		// ...
		return 1;
	}

	private void other() {
		System.out.println("other()");
	}

	private void trace(BottomNode bin, LeafNode ln, long position) {
		System.out.println("trace(" + bin + ", " + ln + ", " + position + ")");
	}

	private BottomNode findBINForInsert(byte[] key) {
		System.out.println("findBINForInsert(" + key + ")");
		return new BottomNode();
	}
}