package progressive;

class A exhibits JP_A {
	pointcut JP_A : execution(void foo());

	void foo() { System.out.println("A.foo()"); }
}

class B extends A {
	void foo() { System.out.println("B.foo()"); }
	void fooB() { System.out.println("B.fooB()"); }
}

joinpointtype JP_A {}
joinpointtype JP_B extends JP_A {}

aspect X advises JP_A {
	before(JP_A a) {
		System.out.println("\t**\t"+thisJoinPoint);
	}
}

class Test {
	public static void main(String[] args) {
		B b = new B();
		b.foo();
		b.fooB();
	}
}