package objects;

import joinpointtypes.*;

public class NamedPrinter extends PrinterExt exhibits Printing {
	
	pointcut Printing : super;
	
	private String name;
	
	public NamedPrinter(String name) {
		this.name = name;
	}
	
	@Override
	public void print(String text) {
		System.out.println(prefix()+text);
	}
	
	private String prefix() {
		return name+" : ";
	}

	@Override
	public void print(String text, int numberOfPrints) {
//		for(int i = 0; i < numberOfPrints; i++) {
//			System.out.println(i+" "+prefix()+text);
//		}
		super.print(prefix()+text,numberOfPrints);
	}
	

}
